/************************************************************************
 *   IRC - Internet Relay Chat, src/m_version.c
 *   Copyright (C) 1990 Jarkko Oikarinen and
 *                      University of Oulu, Computing Center
 *
 *   See file AUTHORS in IRC package for additional names of
 *   the programmers. 
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 1, or (at your option)
 *   any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *   GNU General Public License for more details.
 *
 *   You should have received a copy of the GNU General Public License
 *   along with this program; if not, write to the Free Software
 *   Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 *
 *   $Id: m_admin.c,v 1.1.1.2 2001/02/02 20:59:39 jpinto Exp $
 */

#include "irc_string.h"
#include "m_commands.h"
#include "string.h"
#include "client.h"
#include "ircd.h"
#include "numeric.h"
#include "s_conf.h"
#include "string.h"
#include "s_serv.h"
#include "send.h"
#include "conf_vars.h"
#include "stline.h"

/*
 * m_functions execute protocol messages on this server:
 *
 *      cptr    is always NON-NULL, pointing to a *LOCAL* client
 *              structure (with an open socket connected!). This
 *              identifies the physical socket where the message
 *              originated (or which caused the m_function to be
 *              executed--some m_functions may call others...).
 *
 *      sptr    is the source of the message, defined by the
 *              prefix part of the message if present. If not
 *              or prefix not found, then sptr==cptr.
 *
 *              (!IsServer(cptr)) => (cptr == sptr), because
 *              prefixes are taken *only* from servers...
 *
 *              (IsServer(cptr))
 *                      (sptr == cptr) => the message didn't
 *                      have the prefix.
 *
 *                      (sptr != cptr && IsServer(sptr) means
 *                      the prefix specified servername. (?)
 *
 *                      (sptr != cptr && !IsServer(sptr) means
 *                      that message originated from a remote
 *                      user (not local).
 *
 *              combining
 *
 *              (!IsServer(sptr)) means that, sptr can safely
 *              taken as defining the target structure of the
 *              message in this server.
 *
 *      *Always* true (if 'parse' and others are working correct):
 *
 *      1)      sptr->from == cptr  (note: cptr->from == cptr)
 *
 *      2)      MyConnect(sptr) <=> sptr == cptr (e.g. sptr
 *              *cannot* be a local connection, unless it's
 *              actually cptr!). [MyConnect(x) should probably
 *              be defined as (x == x->from) --msa ]
 *
 *      parc    number of variable parameter strings (if zero,
 *              parv is allowed to be NULL)
 *
 *      parv    a NULL terminated list of parameter pointers,
 *
 *                      parv[0], sender (prefix string), if not present
 *                              this points to an empty string.
 *                      parv[1]...parv[parc-1]
 *                              pointers to additional parameters
 *                      parv[parc] == NULL, *always*
 *
 *              note:   it is guaranteed that parv[0]..parv[parc-1] are all
 *                      non-NULL pointers.
 */

/*
 * m_admin - ADMIN command handler
 *      parv[0] = sender prefix
 *      parv[1] = servername
 */
int m_admin(struct Client *cptr, struct Client *sptr, int parc, char *parv[])
{
//struct ConfItem *aconf;
  static time_t last_used=0L;

  if(!IsAnOper(sptr))
    {
      if((last_used + PACE_WAIT) > CurrentTime)
        {
          /* safe enough to give this on a local connect only */
          if(MyClient(sptr))
            sendto_one(sptr,form_str(RPL_LOAD2HI),MENAME(sptr),parv[0]);
          return 0;
        }
      else
        last_used = CurrentTime;
    }

/*if (IsRegisteredUser(sptr) && (hunt_server(cptr,sptr,":%s ADMIN :%s",1,parc,parv) != HUNTED_ISME))
    return 0; */

  if (IsPerson(sptr))
    sendto_realops_flags(FLAGS_SPY,
                         "ADMIN requested by %s (%s@%s) [%s]", sptr->name,
                         sptr->username, sptr->host, MENAME(sptr));

/* static info --pier */
sendto_one(sptr, form_str(RPL_ADMINME),   MENAME(sptr), parv[0], MENAME(sptr));
sendto_one(sptr, form_str(RPL_ADMINLOC1), MENAME(sptr), parv[0], "BraSmIRC - Rede Brasileira de IRC");
sendto_one(sptr, form_str(RPL_ADMINLOC2), MENAME(sptr), parv[0], "Admin");

{
 char email[512];
 int D = 1; /* 1 = @brasmirc.org */
 aConfItem *stl = stlines;

 strcpy(email, "ircadmin@");

 /* get @host from stlines -- pier */
 if (sptr->user->vs) {
    while(stl && !match(stl->passwd, sptr->user->vs))
        stl = stl->next;
    if (stl) {
        if (strncmp(stl->name, "irc.", 4) == 0) {
            int len = strlen(stl->name) - 4;
            memcpy(email+9, stl->name+4, len); /* 9 = strlen(ircadmin@) */
            email[len+9] = '\0';
            D = 0;
        }
    }
 }

 if (D) strcat(email, "brasmirc.org");
 sendto_one(sptr, form_str(RPL_ADMINEMAIL), MENAME(sptr), parv[0], email);
}

#if 0 /* ..and do not show any real info */
 if ((aconf = find_admin()))
    {
      sendto_one(sptr, form_str(RPL_ADMINME),
                 MENAME(sptr), parv[0], MENAME(sptr));
      sendto_one(sptr, form_str(RPL_ADMINLOC1),
                 MENAME(sptr), parv[0], aconf->host);
      sendto_one(sptr, form_str(RPL_ADMINLOC2),
                 MENAME(sptr), parv[0], aconf->passwd);
      sendto_one(sptr, form_str(RPL_ADMINEMAIL),
                 MENAME(sptr), parv[0], aconf->user);
    }
  else
    sendto_one(sptr, form_str(ERR_NOADMININFO),
               MENAME(sptr), parv[0], MENAME(sptr));
#endif

  return 0;
}

